SystemOrganization addCategory: #ConfigurationOfGTExamplesCore!

Object subclass: #ConfigurationOfGTExamplesCore
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfGTExamplesCore'!

!ConfigurationOfGTExamplesCore class methodsFor: 'development support' stamp: 'StefanReichhart 3/18/2017 15:34'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>! !

!ConfigurationOfGTExamplesCore class methodsFor: 'private' stamp: 'StefanReichhart 3/18/2017 15:34'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #'ConfigurationOf'
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #'ConfigurationOf' ifAbsent: aBlock ].! !

!ConfigurationOfGTExamplesCore class methodsFor: 'private' stamp: 'StefanReichhart 3/18/2017 15:34'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfGTExamplesCore class methodsFor: 'private' stamp: 'StefanReichhart 3/18/2017 15:34'!
ensureMetacelloBaseConfiguration
  Smalltalk
    at: #'ConfigurationOf'
    ifAbsent: [ 
      | repository version |
      repository := MCHttpRepository
        location: 'http://smalltalkhub.com/mc/dkh/metacello/main'
        user: ''
        password: ''.
      repository
        versionReaderForFileNamed: 'Metacello-Base-dkh.107'
        do: [ :reader | 
          version := reader version.
          version load.
          version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfGTExamplesCore class methodsFor: 'metacello tool support' stamp: 'StefanReichhart 3/18/2017 15:34'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfGTExamplesCore class methodsFor: 'loading' stamp: 'StefanReichhart 3/18/2017 15:34'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfGTExamplesCore class methodsFor: 'loading' stamp: 'StefanReichhart 3/18/2017 15:34'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfGTExamplesCore class methodsFor: 'loading' stamp: 'StefanReichhart 3/18/2017 15:34'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfGTExamplesCore class methodsFor: 'accessing' stamp: 'StefanReichhart 3/18/2017 15:34'!
project

	^self new project! !

!ConfigurationOfGTExamplesCore class methodsFor: 'development support' stamp: 'StefanReichhart 3/18/2017 15:34'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfGTExamplesCore methodsFor: 'baselines' stamp: 'StefanReichhart 3/18/2017 15:35'!
baseline01: spec
	<version: '0.1-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec 
			package: #'GT-Examples';
			package: #'GT-Examples-UI' with: [
				spec requires: #(#'GT-Examples' ). ].
		spec group: 'default' with: #(#'GT-Examples' #'GT-Examples-UI' ). ].
! !

!ConfigurationOfGTExamplesCore methodsFor: 'accessing' stamp: 'StefanReichhart 3/18/2017 15:34'!
customProjectAttributes
    "Edit to return a collection of any custom attributes e.g. for conditional loading: Array with: #'Condition1' with: #'Condition2.
	For more information see: http://code.google.com/p/metacello/wiki/CustomProjectAttrributes "

    ^ #()! !

!ConfigurationOfGTExamplesCore methodsFor: 'symbolic versions' stamp: 'StefanReichhart 3/18/2017 15:34'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '0.1-baseline'.
! !

!ConfigurationOfGTExamplesCore methodsFor: 'accessing' stamp: 'StefanReichhart 3/18/2017 15:34'!
project
    ^ project
        ifNil: [ 
            "Bootstrap Metacello if it is not already loaded"
            self class ensureMetacello.
            project := MetacelloMCProject new projectAttributes: self customProjectAttributes.	"Create the Metacello project"
            (Smalltalk at: #'MetacelloVersionConstructor') on: self project: project.	"Construct the project"
            project loadType: #'linear'.	"change to #atomic if desired"
            project ]! !
